'Determine investment strategy for retirement.
'by Michael Krabach
revdate$="rev 7-25-02"

ON KEY (10) GOSUB stop_pgm
KEY (10) ON

DEFDBL i,j,p,f,b
DEFINT y,n,r,s

menu:
CLS
LOCATE 1,1
COLOR 11
PRINT "==================== Investing for Retirement and After ====================="
COLOR 12
LOCATE 2,60
PRINT "F10 ^ to Exit"
LOCATE 25,67
PRINT revdate$;
LOCATE 3,1
COLOR 14
PRINT "- Investing before retirement: input following data "
COLOR 7
INPUT "Existing investment value? ",initinvst
INPUT "First year initial payment? (0 if no more payments) ",pmt
IF pmt=0 THEN
	INPUT "Years before retirement? (60 max) ",nin
    ELSE
	INPUT "Pay in for how many (60 max) years? ",nin
END IF
INPUT "Assumed average investment rate of return, %? ",iin
INPUT "Assumed average inflation, %? ",jin
COLOR 14
PRINT "- Withdrawal during retirement: input following data "
COLOR 7
INPUT "Withdraw for how many (60 max) years? ",nout
INPUT "Assumed average investment rate of return, %? ",iout
INPUT "Assumed average inflation, %? ",jout

iin=iin/100
jin=jin/100
iout=iout/100
jout=jout/100

ieffin=(1+iin)/(1+jin)-1		'i' effective Rate Of Return while investing
ieffout=(1+iout)/(1+jout)-1 	'i' effective ROR while divesting

idiff=ieffin-jin
IF idiff<>0 THEN pvsumin=((1+ieffin)^nin-(1+jin)^nin)*(1+ieffin)/idiff ELSE pvsumin=nin*(1+ieffin)^nin
IF idiff<>0 THEN pvinit=initinvst*(1+ieffin)^nin ELSE pvinit=initinvst
pvrtnin=pvsumin*pmt+pvinit
bal=pvrtnin
COLOR 14
PRINT "- At retirement your worth is:"
COLOR 7
PRINT "Present Value (constant value $'s) of investment fund is ";
    COLOR 15
	PRINT USING "**$#######,.##";pvrtnin
	COLOR 7

idiff=iin-jin
IF idiff<>0 THEN fvsumin=((1+iin)^nin-(1+jin)^nin)*(1+iin)/idiff ELSE fvsumin=nin*(1+iin)^nin
IF idiff<>0 THEN fvinit=initinvst*(1+iin)^nin ELSE fvinit=initinvst
fvrtnin=fvsumin*pmt+fvinit

PRINT "Future Value (inflated value $'s) of investment fund is ";
    COLOR 15
	PRINT USING "**$#######,.##";fvrtnin
    COLOR 7


wdrw=(initinvst+pmt*nin)/nout		'a first guess value for solution
IF ieffout<>0 THEN invest=wdrw*((1/(1+ieffout))^nout-1)/((1/(1+ieffout))-1) ELSE invest=wdrw*nout
wdrw=pvrtnin*wdrw/invest	'simple ratio gets answer, no iteration needed

PRINT "Your allowable starting retirement withdrawal (in PV $'s) is ";
COLOR 15
PRINT USING "**$########,.##"; wdrw
PRINT
COLOR 11

label_1:
LOCATE 24,2
INPUT "Choose option:  New input,  Cash flow,  Quit  [n,c,q]"; ans$
SELECT CASE ans$
	CASE "n"
    GOSUB menu
    CASE "c"
    GOSUB cash_in
    CASE "q"
	GOSUB stop_pgm
	CASE ELSE
    GOTO label_1
END SELECT
STOP

'===========================================================================

cash_in:
r=3: s=1 	'starting screen pointers for tabular data output
COLOR 14
CLS
PRINT "-------------------------- Cash Flow into Investment --------------------------"
COLOR 12
LOCATE 2,60
PRINT "F10 ^ to Exit"
COLOR 14
LOCATE r,s
	PRINT "Yr  Payment    Total PV    Total FV     Yr  Payment    Total PV    Total FV    "
COLOR 10

pvsumin=0
fvsumin=0

FOR year=1 TO nin
    IF year=41 THEN
    	COLOR 13
    	LOCATE 24,52
    	PRINT "Space lists more data."
        GOSUB waitabit
    	r=-37: s=1 	'starting screen pointers for tabular data output
	END IF
jpmt=pmt*(1+jin)^(year-1)           'new pmt for each inflation period
pvsumin=pvsumin+jpmt
fvsumin=fvsumin+jpmt
pvsumin=pvsumin*(1+ieffin)
fvsumin=fvsumin*(1+iin)
    LOCATE (r+year),s
    	PRINT USING "##";year
    LOCATE (r+year),s+3
    	PRINT USING "**$#####,";jpmt
	LOCATE (r+year),s+14
    	PRINT USING "**$#######,";pvsumin+initinvst*(1+ieffin)^(year)
    LOCATE (r+year),s+26
    	PRINT USING "**$#######,";fvsumin+initinvst*(1+iin)^(year)
    IF year=20 THEN
		s=s+40
        r=-17
    END IF
NEXT year

Label_2:
LOCATE 24,52
COLOR 11
PRINT "                        "
LOCATE 24,1
INPUT "Choose option:  New input,  Cash flow out,  Quit  [n,c,q]";ans$
SELECT CASE ans$
	CASE "n"
    GOSUB menu
    CASE "c"
    GOSUB cash_out
    CASE "q"
	GOSUB stop_pgm
    CASE ELSE
    GOTO Label_2
END SELECT


'===========================================================================
cash_out:
r=3: s=1 	'starting screen pointers for tabular data output
CLS
COLOR 14
PRINT "----------------------- Cash Withdrawal from Investment ----------------------"
COLOR 12
LOCATE 2,60
PRINT "F10 ^ to Exit"
COLOR 14
LOCATE r,s
	PRINT "Yr  Withdraw PV     Balance PV          Yr  Withdraw PV     Balance PV"
COLOR 10

FOR year=1 TO nout
    IF year=41 THEN
    	COLOR 13
    	LOCATE 24,52
    	PRINT "Space lists more data."
    	GOSUB waitabit
    	r=-37: s=1 	'starting screen pointers for tabular data output
	END IF
	bal=bal-wdrw
    LOCATE (r+year),s
    	PRINT USING "##";year
    LOCATE (r+year),s+4
    	PRINT USING "**$######,.##";wdrw
	LOCATE (r+year),s+20
    	PRINT USING "**$#######,.##";bal
    bal=bal*(1+iout)
    wdrw=wdrw*(1+jout)
    IF year=20 THEN
    	s=s+40
        r=-17
    END IF
NEXT year

Label_3:
LOCATE 24,52
COLOR 11
PRINT "                        "
LOCATE 24,1
INPUT "Choose option:  New input,  Quit  [n,q] ";ans$
SELECT CASE ans$
	CASE "n"
    GOSUB menu
    CASE "q"
	GOSUB stop_pgm
    CASE ELSE
	GOTO Label_3
END SELECT

RETURN

waitabit:
WHILE NOT INSTAT : WEND
a$=INKEY$
RETURN

stop_pgm:
CLS
END