'Determine investment strategy for retirement.
'by Michael Krabach
revdate$="rev 3-01-02"

invst:
DEFDBL i,j,p,f,b
DEFINT y,n,r,s
ON KEY (10) GOSUB stop_pgm
KEY (10) ON
CLS
LOCATE 1,1
COLOR 11
PRINT "====================== Investing before Retirement ========================="
COLOR 12
LOCATE 2,60
PRINT "F10 ^ to Exit";
LOCATE 25,67
PRINT revdate$;
LOCATE 2,1
COLOR 7
INPUT "Existing investment value? ",initinvst
INPUT "First year initial payment? ",pmt
IF pmt=0 THEN
	INPUT "Leave in for how many (40 max) years? ",n
    ELSE
	INPUT "Pay in for how many (40 max) years? ",n
END IF
INPUT "Assumed average investment rate of return, %? ",i
INPUT "Assumed average inflation, %? ",j

i=i/100
j=j/100

ieff=(1+i)/(1+j)-1	'is (1+i') effective interst rate

idiff=ieff-j
IF idiff<>0 THEN pvsum=((1+ieff)^n-(1+j)^n)*(1+ieff)/idiff ELSE pvsum=n*(1+ieff)^n
IF idiff<>0 THEN pvinit=initinvst*(1+ieff)^n ELSE pvinit=initinvst
pvrtn=pvsum*pmt+pvinit
PRINT "Present Value (todays $'s) of investment fund is ";
    COLOR 15
	PRINT USING "**$#######,.##";pvrtn
	COLOR 7

idiff=i-j
IF idiff<>0 THEN fvsum=((1+i)^n-(1+j)^n)*(1+i)/idiff ELSE fvsum=n*(1+i)^n
IF idiff<>0 THEN fvinit=initinvst*(1+i)^n ELSE fvinit=initinvst
fvrtn=fvsum*pmt+fvinit
PRINT "Future Value (future $'s) of investment fund is ";
    COLOR 15
	PRINT USING "**$#######,.##";fvrtn
    COLOR 7

pvsum=0		'clear registers
fvsum=0

r=10: s=1 	'starting screen pointers for tabular data output
COLOR 14
PRINT "----------------------------- Cash Flow Listing -----------------------------"
LOCATE r,s
	PRINT "Yr  Payment    Total PV    Total FV     Yr  Payment    Total PV    Total FV    "
COLOR 10

FOR year=1 TO n
    IF year=27 THEN
    	COLOR 13
    	LOCATE 24,52
    	PRINT "Space lists more data."
        GOSUB waitabit
    	r=-16: s=1 	'starting screen pointers for tabular data output
	END IF

jpmt=pmt*(1+j)^(year-1)
pvsum=pvsum+jpmt
fvsum=fvsum+jpmt
pvsum=pvsum*(1+ieff)
fvsum=fvsum*(1+i)
    LOCATE (r+year),s
    	PRINT USING "##";year
    LOCATE (r+year),s+3
    	PRINT USING "**$#####,";jpmt
	LOCATE (r+year),s+14
    	PRINT USING "**$#######,";pvsum+initinvst*(1+ieff)^(year)
    LOCATE (r+year),s+26
    	PRINT USING "**$#######,";fvsum+initinvst*(1+i)^(year)
    IF year=13 THEN
    	s=s+40
        r=-3
    END IF
NEXT year

COLOR 12
LOCATE 2,60
PRINT "F10 to Exit  ";
COLOR 13
LOCATE 24,52
PRINT "Space for new input.  ";
COLOR 7

GOSUB waitabit
CLS
GOTO invst
RETURN

waitabit:
WHILE NOT INSTAT : WEND
a$=INKEY$
RETURN

stop_pgm:
CLS
END

