
'Determine investment strategy for retirement.
'by Michael Krabach
revdate$="rev 5-31-02"

ON KEY (10) GOSUB stop_pgm
KEY (10) ON

menu:
CLS
COLOR 14
PRINT "==================== Retirement Analysis Program ======================="
PRINT "                        by Michael Krabach"
COLOR 7
PRINT "                      mkrabach@efortress.com"
PRINT
PRINT
PRINT

PRINT "    All input is based on yearly values, including payments, investment"_
"rate of return and average inflation.  The calculation method is payments-at-"_
"beginning of the period. Payments into and out of the investment are adjusted"_
"for inflation.  'Retire.exe' only runs the three modules; invst.exe, divst.exe"_
"and combo.exe.  The modules can be run individually, if desired."

PRINT
COLOR 12
LOCATE 3,60
PRINT "F10 ^ to Exit";
LOCATE 25,67
PRINT revdate$;
COLOR 14
LOCATE 3,73
PRINT "*";
LOCATE 24,57
PRINT "*";
COLOR 12
LOCATE 24,58
PRINT "Note, ^ means `Enter'";

COLOR 7
LOCATE 13,1
COLOR 11
PRINT "Analyse retirement investment for one of the below cases:"
COLOR 7
PRINT
PRINT "- For the period before retirement: input 'b'"
PRINT "- For the years after retirement: input 'a'"
PRINT "- For the combined years before and after retirement: 'c'"
PRINT "- For help about the program: input 'h'"
PRINT

Label_1:
LOCATE 20,1
COLOR 11
INPUT "Choose [b,a,c,h] ";ans$
COLOR 7
SELECT CASE ans$
	CASE "b"
    SHELL "invst"
    CASE "a"
    SHELL "divst"
	CASE "c"
    SHELL "combo"
    CASE "h"
    GOSUB help
    CASE ELSE
    GOTO Label_1
END SELECT
GOTO menu
END

help:
CLS
COLOR 14
PRINT "====================== Retirement Analysis Program ========================="
PRINT "                        by Michael Krabach
COLOR 7
PRINT "   These programs will assist you in determining how much money you will"_
"need to invest before retiring at some nominal lifestyle, and how long it will"_
"last into your retirement.  Inflation is not often included in an analysis,"_
"but can drastically affect a retirement investment.  These programs give"_
"output in constant (present) dollars which negate the depreciating effects"_
"of inflation.  The future (inflated) dollars are also included for comparison"_
"with present dollars.  For a general look at retirement investing, average"_
"inflation rates and average investment rates are used and are adequate."
PRINT "   This program (retire.exe) will link three programs, invst.exe, divst.exe,"_
"and combo.exe.  Invst.exe will calculate how much an investment plan will be"_
"worth after a number of years.  Divst.exe will determine the yearly amount an"_
"investment will provide over a period.  Note that in invst.exe the payments in-"_
"to the fund are increased by inflation and in divst.exe the withdrawal amount"_
"is increased by inflation.  The same occures in combo.exe. This is a requirement"_
"to allow for the devaluation  of the dollar by inflation.  Combo.exe combines"_
"both investing and withdrawal programs, and solves the allowable withdrawal"_
"after retirement based on the input investing scheme. The programs allow for"_
"a fixed investment to be included at the start of yearly payments.  The"_
"convention used is payments-at-beginning of the period. "
COLOR 14
PRINT "                        Space key to return";
GOSUB waitabit
COLOR 7
GOTO menu
RETURN

waitabit:
WHILE NOT INSTAT : WEND
a$=INKEY$
RETURN

stop_pgm:
CLS
END

